#include "stack.h"
#include <stdlib.h>

int
Stack__init(Stack *s)
{
    s->capacity = 1024;
    s->count = 0;
    if ((s->buffer = malloc(s->capacity * sizeof *s->buffer)) == 0) {
        return 2;
    }
    return 0;
}

void
Stack__final(Stack *s)
{
    free(s->buffer);
}

int
Stack__push(Stack *s, int value)
{
    if (s->capacity == s->count) {
        return 1;
    }
    s->buffer[s->count ++] = value;
    return 0;
}

int
Stack__pop(Stack *s, int *value)
{
    if (s->count == 0) {
        return 1;
    }
    *value = s->buffer[-- s->count];
    return 0;
}
